% snail.gml
%
% A growing snail
%

{ 	  % generate surface functions for a given brightness
  /bri		 
  { /v /u /face			  % bind arguments
    1.0   1.0 bri subf  bri point		  % surface color
    1.0 0.0 3.0			  % kd ks n
  }
} /genColor                      



%%{ /v /u /face
%%  1.0 1.0 1.0 point
%%  1.0 0.0 1.0
%%} plane 0.0 -4.0 0.0 translate 


{
  /self /scene /n
  0 n  lessi 
  { 
    n real 0.025 mulf  
      genColor apply  
         sphere
         0.7 uscale
         2.0 0.0 0.0 translate
    scene 
      0.90 uscale 
      35.0 rotatez
    union /scene

    n 1 subi scene self self apply 
  }
  {  scene }
  if
} /snail

40                     % counter
1.0 genColor apply sphere % the beginning scene
snail                 % recursion aid
snail apply
0.0 0.0 3.0 translate
65.0 rotatez
/thescene


1.0 -1.0 0.0 point		  % direction
1.0  1.0 1.0 point light /l	  % directional light

0.4 0.4 0.4 point		  % ambient light
[ l ]				  % lights
thescene			  % scene to render
3				  % tracing depth
70.0				  % field of view
100 75				  % image wid and height
"snail.ppm"			  % output file
render

