#!/bin/sh
#$Id: mkdist.sh,v 1.2 2000/08/29 10:28:37 konrad Exp $

echo "Making a fresh CuttySark distribution"

rm -rf dist
mkdir dist
mkdir dist/src
mkdir dist/support
mkdir dist/support/gmltests

for i in DummyFactory.py Exceptions.py GMLTypes.py Ops.py Optimizer.py\
  Parser.py PrettyPrint.py Stack.py Stackmachine.py Test.py TestOpti.py Run.py\
  cedric/RayTrace.py cedric/MathLib.py cedric/Intersection.py
do 
  echo copying source $i
  cp $i dist/src
done

cp README runme buildme dist
chmod 755 dist/runme dist/buildme

cp -r tests/*.gml dist/support/gmltests

cp mkdist.sh dist/support

cd dist
echo "making CuttySark.tar.gz"
tar cfz ../CuttySark.tar.gz .
cd ..
